//
// Generated stub from file:/Users/mclay/workspace/openXMA/org.codehaus.openxma.xmapack/target/checkout/src/main/groovy/org/codehaus/xma/mojo/packager/PackageMojo.groovy
//

package org.codehaus.xma.mojo.packager;

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import groovy.lang.*;
import groovy.util.*;
import org.apache.maven.plugin.Mojo;
import org.codehaus.groovy.maven.mojo.GroovyMojo;
import org.codehaus.plexus.component.configurator.ComponentConfigurator;
import org.codehaus.plexus.component.configurator.expression.ExpressionEvaluator;
import org.codehaus.plexus.configuration.PlexusConfiguration;
import org.codehaus.plexus.configuration.xml.XmlPlexusConfiguration;
import org.codehaus.plexus.util.ReflectionUtils;
import org.codehaus.plexus.util.xml.Xpp3Dom;
import org.codehaus.plexus.util.xml.Xpp3DomBuilder;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.DirectoryScanner;
import java.util.HashSet;

/**
 * Packager Mojo used to wrap and provide the existing xma ant facility as maven plugin.
 * <p>
 * The components to be packaged can be provided using four different methods:
 * <ul>
 * <li>Using the <xmp><components><xmp> element with a list of componentName=componentPackage style values
 * (e.g. customeredit=org/openxma/dsl/reference/xma/customeredit/)
 * <li>Using the <xmp><components><xmp> element with a list of componentPackage values (e.g.
 * org/openxma/dsl/reference/xma/customeredit/)
 * <li>Omitting the components element and defining an xmaXmlFilter element with an ANT fileset style filter value
 * <li>Omitting any of these, which results in packaging all XMA components in the source folder.
 * </ul>
 * <p>
 * Providing a filter as well as excplicit components results in packaging the components first,
 * then searching for further components using the filter and packageing those, too. The filter may
 * also include the explicitely defined components.
 * <p>
 * An example with all the possibilities used:
 * <p>
 * <xmp>
 * <xmaXmlFilter>**&amp;#047;*.xma</xmaXmlFilter>
 * <components>
 * <component>customeredit=org/openxma/dsl/reference/xma/customeredit/</component>
 * <component>org/openxma/dsl/reference/xma/customeredit2/</component>
 * </components>
 * 
 * <xmp>
 *
 * @goal package
 * @requiresDependencyResolution
 */
public class PackageMojo
    extends GroovyMojo
{
    /**
     * @parameter expression="${project}"
     * @required
     * @readonly
     */
    private org.apache.maven.project.MavenProject project = null;
    public org.apache.maven.project.MavenProject getProject() {
        throw new InternalError("Stubbed method");
    }
    public void setProject(org.apache.maven.project.MavenProject value) {
        throw new InternalError("Stubbed method");
    }

    /**
     * @parameter expression="${session}"
     * @required
     * @readonly
     */
    private org.apache.maven.execution.MavenSession session = null;
    public org.apache.maven.execution.MavenSession getSession() {
        throw new InternalError("Stubbed method");
    }
    public void setSession(org.apache.maven.execution.MavenSession value) {
        throw new InternalError("Stubbed method");
    }

    /**
     * @parameter expression="${basedir}/src/main/webapp/"
     */
    private java.lang.String appDescriptorDirectory = null;

    /**
     * @parameter
     */
    private java.lang.String xmaXmlFilter = null;

    /**
     * @parameter expression="xma-app.xml"
     */
    private java.lang.String appDescriptorFileName = null;

    /**
     * @parameter expression="plugins.xml"
     */
    private java.lang.String pluginsDescriptorFileName = null;

    /**
     * @parameter
     * @optional
     */
    private List plugins = null;

    /**
     * @parameter
     * @optional
     */
    private List components = null;

    /**
     * @parameter
     */
    private List clientLibraries = null;

    /**
     * @parameter
     * @optional
     */
    private List clientIncludes = null;

    /**
     * @parameter expression="${project.build.directory}/xma/components"
     */
    private java.lang.String componentsBuildDirectory = null;

    /**
     * @parameter expression="${project.build.directory}/xma/plugins"
     */
    private java.lang.String pluginsBuildDirectory = null;

    /**
     * @parameter expression="${project.build.directory}/xma/dependencies"
     */
    private java.lang.String dependenciesBuildDirectory = null;

    /**
     * @parameter expression="${project.build.directory}/xma/web"
     */
    private java.lang.String xmaDirectory = null;

    /**
     * @parameter expression="${project.build.directory}/xma/web/components"
     */
    private java.lang.String componentsDirectory = null;

    /**
     * @parameter expression="${project.build.directory}/xma/web/plugins"
     */
    private java.lang.String pluginsDirectory = null;

    /**
     * @parameter expression="${project.build.directory}/xma/web/clientrt"
     */
    private java.lang.String clientRtDirectory = null;

    /**
     * @parameter default-value="commonclient"
     */
    private java.lang.String commonClientJarName = null;

    public void execute() {
        throw new InternalError("Stubbed method");
    }

    public boolean appDescriptorFileExists() {
        throw new InternalError("Stubbed method");
    }

    public boolean pluginsDescriptorFileExists() {
        throw new InternalError("Stubbed method");
    }

    public java.lang.String createBuildDirectories() {
        throw new InternalError("Stubbed method");
    }

    public void copyDependencyArtifacts() {
        throw new InternalError("Stubbed method");
    }

    public void jarComponentsAndCreateChecksum(java.lang.Object fastDevelopmentMode) {
        throw new InternalError("Stubbed method");
    }

    public void packComponents() {
        throw new InternalError("Stubbed method");
    }

    public void packComponent(java.lang.Object componentName, java.lang.Object componentPackage) {
        throw new InternalError("Stubbed method");
    }

    public void packPlugins() {
        throw new InternalError("Stubbed method");
    }

    public void copyClientLibraries() {
        throw new InternalError("Stubbed method");
    }

    public void jarClientIncludes() {
        throw new InternalError("Stubbed method");
    }

    public void copyComponentsAndApplicationDescriptor(java.lang.Object fastDevelopmentMode) {
        throw new InternalError("Stubbed method");
    }

    public groovy.lang.MetaClass getMetaClass() {
        throw new InternalError("Stubbed method");
    }

    public void setMetaClass(groovy.lang.MetaClass metaClass) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object invokeMethod(java.lang.String name, java.lang.Object args) {
        throw new InternalError("Stubbed method");
    }

    public java.lang.Object getProperty(java.lang.String name) {
        throw new InternalError("Stubbed method");
    }

    public void setProperty(java.lang.String name, java.lang.Object value) {
        throw new InternalError("Stubbed method");
    }
}
